import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.net.URI;
import java.net.URL;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.LinkedList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.utils.URIUtils;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;

public class Program {

	

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		BufferedReader br = null;
		List <String> adreces = new LinkedList<String>();
	    try {
	    	br = new BufferedReader(new InputStreamReader(
                    new FileInputStream(new File("farmacies.txt")), "UTF-8"));
	        //StringBuilder sb = new StringBuilder();
	         
	        String line = br.readLine();

	        while (line != null) {
	        	adreces.add(line);
	            /*sb.append(line);
	            sb.append(System.lineSeparator());*/
	            line = br.readLine();
	            //System.out.println(line);
	        }
	        //String everything = sb.toString();
	    } catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
	        try {
				br.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
	    }
	    
	    //System.out.println(getLatLong(adreces.get(0)));
	    
	    BufferedWriter bw = null;
	    try {
			bw = new BufferedWriter(new OutputStreamWriter(
			        new FileOutputStream(new File("farmacies-geo.txt")), "UTF-8"));
			
			for (int i=1999; i<adreces.size(); i++) {
				bw.write(getLatLong(adreces.get(i)));
				bw.newLine();
				System.out.println(i);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			try {
				bw.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	    
	}
	
	public static String getLatLong(String adreca) {
		InputStream inputStream = null;
        String json = "";

        try {
            HttpClient client = new DefaultHttpClient(); 
            String a = URLEncoder.encode(adreca,"UTF-8");
            HttpPost post = new HttpPost("https://maps.googleapis.com/maps/api/geocode/json?address="+a);
            HttpResponse response = client.execute(post);
            HttpEntity entity = response.getEntity();
            inputStream = entity.getContent();
        } catch(Exception e) {
        	System.out.println(e.getMessage());
        }

        try {           
            BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream,"utf-8"),8);
            StringBuilder sbuild = new StringBuilder();
            String line = null;
            while ((line = reader.readLine()) != null) {
                sbuild.append(line);
            }
            inputStream.close();
            json = sbuild.toString();               
        } catch(Exception e) {
        	System.out.println(e.getMessage());
        	return "null";
        }


        //now parse
        JSONParser parser = new JSONParser();
        Object obj = null;
		try {
			obj = parser.parse(json);
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "null";
		}
        JSONObject jb = (JSONObject) obj;

        //now read
        JSONArray jsonObject1 = (JSONArray) jb.get("results");
        if (jsonObject1.isEmpty()) return adreca + ";null";
        JSONObject jsonObject2 = (JSONObject)jsonObject1.get(0);
        JSONObject jsonObject3 = (JSONObject)jsonObject2.get("geometry");
        JSONObject location = (JSONObject) jsonObject3.get("location");
	    
	    return(adreca + ";" + jsonObject2.get("formatted_address").toString() + ";" + location.get("lat").toString() + ";" + location.get("lng").toString());
	}
}
